3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
6 USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit>] [-u] [--amend] [-e] [--author <author>] [[-i | -o] <path>...]'
10 git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
11 branch=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD)
16 unmerged_ok_if_status=--unmerged ;;
19 unmerged_ok_if_status= ;;
24 echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
28 THIS_INDEX="$GIT_DIR/index"
29 NEXT_INDEX="$GIT_DIR/next-index$$"
32 cp "$THIS_INDEX" "$NEXT_INDEX"
42 while read status name newname
49 M ) echo "# modified: $name";;
50 D*) echo "# deleted: $name";;
51 T ) echo "# typechange: $name";;
52 C*) echo "# copied: $name -> $newname";;
53 R*) echo "# renamed: $name -> $newname";;
54 A*) echo "# new file: $name";;
55 U ) echo "# unmerged: $name";;
58 printf '%s' "$trailer"
64 # We always show status for the whole tree.
67 IS_INITIAL="$initial_commit"
71 # If we are amending the initial commit, there
73 if git-rev-parse --verify "HEAD^1" >/dev/null 2>&1
83 # If TMP_INDEX is defined, that means we are doing
84 # "--only" partial commit, and that index file is used
85 # to build the tree for the commit. Otherwise, if
86 # NEXT_INDEX exists, that is the index file used to
87 # make the commit. Otherwise we are using as-is commit
88 # so the regular index file is what we use to compare.
89 if test '' != "$TMP_INDEX"
91 GIT_INDEX_FILE="$TMP_INDEX"
93 elif test -f "$NEXT_INDEX"
95 GIT_INDEX_FILE="$NEXT_INDEX"
100 refs/heads/master) ;;
101 *) echo "# On branch $branch" ;;
104 if test -z "$IS_INITIAL"
106 git-diff-index -M --cached --name-status \
107 --diff-filter=MDTCRA $REFERENCE |
112 report "Updated but not checked in" "will commit"
124 report "Updated but not checked in" "will commit"
129 git-diff-files --name-status |
134 report "Changed but not updated" \
135 "use git-update-index to mark for commit"
138 if test -z "$untracked_files"; then
139 option="--directory --no-empty-directory"
141 if test -f "$GIT_DIR/info/exclude"
143 git-ls-files -z --others $option \
144 --exclude-from="$GIT_DIR/info/exclude" \
145 --exclude-per-directory=.gitignore
147 git-ls-files -z --others $option \
148 --exclude-per-directory=.gitignore
159 print "#\n# Untracked files:\n";
160 print "# (use \"git add\" to add to commit)\n";
168 if test -n "$verbose" -a -z "$IS_INITIAL"
170 git-diff-index --cached -M -p --diff-filter=MDTCRA $REFERENCE
172 case "$committable" in
176 echo "# No changes" ;;
178 echo "nothing to commit" ;;
187 test -z "$TMP_INDEX" || {
188 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
193 ################################################################
194 # Command line argument parsing and sanity checking
209 only_include_assumed=
211 while case "$#" in 0) break;; esac
214 -F|--F|-f|--f|--fi|--fil|--file)
215 case "$#" in 1) usage ;; esac
218 log_given=t$log_given
224 log_given=t$log_given
225 logfile=`expr "$1" : '-[Ff]\(.*\)'`
228 --F=*|--f=*|--fi=*|--fil=*|--file=*)
230 log_given=t$log_given
231 logfile=`expr "$1" : '-[^=]*=\(.*\)'`
238 --au=*|--aut=*|--auth=*|--autho=*|--author=*)
239 force_author=`expr "$1" : '-[^=]*=\(.*\)'`
242 --au|--aut|--auth|--autho|--author)
243 case "$#" in 1) usage ;; esac
248 -e|--e|--ed|--edi|--edit)
252 -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
256 -o|--o|--on|--onl|--only)
260 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
261 case "$#" in 1) usage ;; esac
263 log_given=m$log_given
264 if test "$log_message" = ''
268 log_message="$log_message
276 log_given=m$log_given
277 if test "$log_message" = ''
279 log_message=`expr "$1" : '-m\(.*\)'`
281 log_message="$log_message
283 `expr "$1" : '-m\(.*\)'`"
288 --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
289 log_given=m$log_given
290 if test "$log_message" = ''
292 log_message=`expr "$1" : '-[^=]*=\(.*\)'`
294 log_message="$log_message
296 `expr "$1" : '-[^=]*=\(.*\)'`"
301 -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|--no-verify)
305 --a|--am|--ame|--amen|--amend)
307 log_given=t$log_given
312 case "$#" in 1) usage ;; esac
314 log_given=t$log_given
319 --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
320 --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
321 --reedit-messag=*|--reedit-message=*)
322 log_given=t$log_given
323 use_commit=`expr "$1" : '-[^=]*=\(.*\)'`
327 --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
328 --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|--reedit-message)
329 case "$#" in 1) usage ;; esac
331 log_given=t$log_given
337 case "$#" in 1) usage ;; esac
339 log_given=t$log_given
344 --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
345 --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
347 log_given=t$log_given
348 use_commit=`expr "$1" : '-[^=]*=\(.*\)'`
352 --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
353 --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
354 case "$#" in 1) usage ;; esac
356 log_given=t$log_given
361 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
365 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
369 -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|--untracked|\
370 --untracked-|--untracked-f|--untracked-fi|--untracked-fil|--untracked-file|\
388 ################################################################
389 # Sanity check options
391 case "$amend,$initial_commit" in
393 die "You do not have anything to amend." ;;
395 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
396 die "You are in the middle of a merge -- cannot amend."
402 die "Only one of -c/-C/-F can be used." ;;
404 die "Option -m cannot be combined with -c/-C/-F." ;;
407 case "$#,$also,$only,$amend" in
409 die "Only one of --include/--only can be used." ;;
411 die "No paths with --include/--only does not make sense." ;;
413 only_include_assumed="# Clever... amending the last one with dirty index." ;;
417 only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
422 case "$all,$also,$#" in
424 die "Cannot use -a and -i at the same time." ;;
426 die "Paths with -a does not make sense." ;;
428 die "No paths with -i does not make sense." ;;
431 ################################################################
432 # Prepare index to have a tree to be committed
434 TOP=`git-rev-parse --show-cdup`
445 GIT_INDEX_FILE="$NEXT_INDEX"
446 export GIT_INDEX_FILE
447 git-diff-files --name-only -z |
448 git-update-index --remove -z --stdin
453 git-ls-files --error-unmatch -- "$@" >/dev/null || exit
455 git-diff-files --name-only -z -- "$@" |
458 GIT_INDEX_FILE="$NEXT_INDEX"
459 export GIT_INDEX_FILE
460 git-update-index --remove -z --stdin
468 if test -f "$GIT_DIR/MERGE_HEAD"
470 refuse_partial "Cannot do a partial commit during a merge."
472 TMP_INDEX="$GIT_DIR/tmp-index$$"
473 if test -z "$initial_commit"
475 # make sure index is clean at the specified paths, or
476 # they are additions.
477 dirty_in_index=`git-diff-index --cached --name-status \
478 --diff-filter=DMTU HEAD -- "$@"`
479 test -z "$dirty_in_index" ||
480 refuse_partial "Different in index and the last commit:
483 commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
485 # Build the temporary index and update the real index
487 if test -z "$initial_commit"
489 cp "$THIS_INDEX" "$TMP_INDEX"
490 GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
495 echo "$commit_only" |
496 GIT_INDEX_FILE="$TMP_INDEX" \
497 git-update-index --add --remove --stdin &&
500 echo "$commit_only" |
502 GIT_INDEX_FILE="$NEXT_INDEX"
503 export GIT_INDEX_FILE
504 git-update-index --remove --stdin
511 ################################################################
512 # If we do as-is commit, the index file will be THIS_INDEX,
513 # otherwise NEXT_INDEX after we make this commit. We leave
514 # the index as is if we abort.
516 if test -f "$NEXT_INDEX"
518 USE_INDEX="$NEXT_INDEX"
520 USE_INDEX="$THIS_INDEX"
523 GIT_INDEX_FILE="$USE_INDEX" \
524 git-update-index -q $unmerged_ok_if_status --refresh || exit
526 ################################################################
527 # If the request is status, just show it and exit.
535 ################################################################
536 # Grab commit message, write out tree and make commit.
538 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
542 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
544 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
548 if test "$log_message" != ''
551 elif test "$logfile" != ""
553 if test "$logfile" = -
556 echo >&2 "(reading log message from standard input)"
561 elif test "$use_commit" != ""
563 git-cat-file commit "$use_commit" | sed -e '1,/^$/d'
564 elif test -f "$GIT_DIR/MERGE_HEAD" && test -f "$GIT_DIR/MERGE_MSG"
566 cat "$GIT_DIR/MERGE_MSG"
567 fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
573 git-var GIT_COMMITTER_IDENT | sed -e '
577 } >>"$GIT_DIR"/COMMIT_EDITMSG
581 if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
583 echo "# It looks like you may be committing a MERGE."
584 echo "# If this is not correct, please remove the file"
585 echo "# $GIT_DIR/MERGE_HEAD"
586 echo "# and try again"
588 fi >>"$GIT_DIR"/COMMIT_EDITMSG
591 if test '' != "$force_author"
593 GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
594 GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
595 test '' != "$GIT_AUTHOR_NAME" &&
596 test '' != "$GIT_AUTHOR_EMAIL" ||
597 die "malformatted --author parameter"
598 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
599 elif test '' != "$use_commit"
603 s/'\''/'\''\\'\'\''/g
605 s/^author \([^<]*\) <[^>]*> .*$/\1/
607 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
610 s/^author [^<]* <\([^>]*\)> .*$/\1/
612 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
615 s/^author [^<]* <[^>]*> \(.*\)$/\1/
617 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
622 set_author_env=`git-cat-file commit "$use_commit" |
623 LANG=C LC_ALL=C sed -ne "$pick_author_script"`
624 eval "$set_author_env"
625 export GIT_AUTHOR_NAME
626 export GIT_AUTHOR_EMAIL
627 export GIT_AUTHOR_DATE
631 if test -z "$initial_commit"
633 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
634 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
635 elif test -n "$amend"; then
636 PARENTS=$(git-cat-file commit HEAD |
637 sed -n -e '/^$/q' -e 's/^parent /-p /p')
639 current=$(git-rev-parse --verify HEAD)
641 if [ -z "$(git-ls-files)" ]; then
642 echo >&2 Nothing to commit
649 if test -z "$no_edit"
653 echo "# Please enter the commit message for your changes."
654 echo "# (Comment lines starting with '#' will not be included)"
655 test -z "$only_include_assumed" || echo "$only_include_assumed"
657 } >>"$GIT_DIR"/COMMIT_EDITMSG
659 # we need to check if there is anything to commit
660 run_status >/dev/null
662 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
664 rm -f "$GIT_DIR/COMMIT_EDITMSG"
671 case "${VISUAL:-$EDITOR},$TERM" in
673 echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
674 echo >&2 "Please supply the commit log message using either"
675 echo >&2 "-m or -F option. A boilerplate log message has"
676 echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
680 git-var GIT_AUTHOR_IDENT > /dev/null || die
681 git-var GIT_COMMITTER_IDENT > /dev/null || die
682 ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
688 if test -x "$GIT_DIR"/hooks/commit-msg
690 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
700 ' "$GIT_DIR"/COMMIT_EDITMSG |
701 git-stripspace >"$GIT_DIR"/COMMIT_MSG
703 if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
708 if test -z "$TMP_INDEX"
710 tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
712 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
715 commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
716 rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
717 git-update-ref -m "commit: $rlogm" HEAD $commit $current &&
718 rm -f -- "$GIT_DIR/MERGE_HEAD" &&
719 if test -f "$NEXT_INDEX"
721 mv "$NEXT_INDEX" "$THIS_INDEX"
726 echo >&2 "* no commit message? aborting commit."
730 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG"
731 if test -d "$GIT_DIR/rr-cache"
736 if test -x "$GIT_DIR"/hooks/post-commit && test "$ret" = 0
738 "$GIT_DIR"/hooks/post-commit